Index: /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90
===================================================================
--- /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 3346)
+++ /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 3347)
@@ -1204,21 +1149,16 @@
                 dist_yz(k,j,2) = 0.0_wp
                 dist_yz(k,j,3) = 0.0_wp
-!                 dist_yz(k,j,4) = 0.0_wp
-!                 dist_yz(k,j,5) = 0.0_wp
              ELSE
-                dist_yz(k,j,1) = a11(k) * fu_yz(k,j)
+                dist_yz(k,j,1) = MIN( a11(k) * fu_yz(k,j), 3.0_wp )
                 !experimental test of 1.2
-                dist_yz(k,j,2) = ( SQRT( a22(k) / MAXVAL(a22) )                &
-                                         * 1.2_wp )                            &
-                                       * (   a21(k) * fu_yz(k,j)               &
-                                           + a22(k) * fv_yz(k,j) )
-                dist_yz(k,j,3) = ( SQRT(a33(k) / MAXVAL(a33) )                 &
-                                         * 1.3_wp )                            &
-                                       * (   a31(k) * fu_yz(k,j)               &
-                                           + a32(k) * fv_yz(k,j)               &
-                                           + a33(k) * fw_yz(k,j) )
-                ! Calculation for pt and e not yet implemented
-!                 dist_yz(k,j,4) = 0.0_wp
-!                 dist_yz(k,j,5) = 0.0_wp
+                dist_yz(k,j,2) = MIN( ( SQRT( a22(k) / MAXVAL(a22) )           &
+                                      * 1.2_wp )                               &
+                                     * (   a21(k) * fu_yz(k,j)                 &
+                                         + a22(k) * fv_yz(k,j) ), 3.0_wp )
+                dist_yz(k,j,3) = MIN( ( SQRT(a33(k) / MAXVAL(a33) )            &
+                                      * 1.3_wp )                               &
+                                    * (   a31(k) * fu_yz(k,j)                  &
+                                        + a32(k) * fv_yz(k,j)                  &
+                                        + a33(k) * fw_yz(k,j) ), 3.0_wp )
              ENDIF
 
@@ -1241,6 +1181,6 @@
 
 #if defined( __parallel )
-          CALL MPI_ALLREDUCE( mc_factor_l, mc_factor,  &
-                              1, MPI_REAL, MPI_SUM, comm1dy, ierr )
+          CALL MPI_ALLREDUCE( mc_factor_l, mc_factor, 1, MPI_REAL, MPI_SUM,    &
+                              comm1dy, ierr )
 #else
           mc_factor = mc_factor_l
@@ -1298,10 +1238,10 @@
 !--       Add disturbances
           IF ( myidx == id_stg_left  )  THEN
-
              DO  j = nys, nyn
-                DO  k = nzb, nzt
+                DO  k = nzb+1, nzt
                    u(k,j,0) = ( u(k,j,0) + dist_yz(k,j,1) )                    &
                        * mc_factor * MERGE( 1.0_wp, 0.0_wp,                    &
                                             BTEST( wall_flags_0(k,j,0), 1 ) )
+                   u(k,j,-1) = u(k,j,0)
                    v(k,j,-1)  = ( v(k,j,-1)  + dist_yz(k,j,2)  )               &
                        * mc_factor * MERGE( 1.0_wp, 0.0_wp,                    &
@@ -1314,7 +1254,6 @@
           ENDIF
           IF ( myidx == id_stg_right  )  THEN
-
              DO  j = nys, nyn
-                DO  k = nzb, nzt
+                DO  k = nzb+1, nzt
                    u(k,j,nxr+1) = ( u(k,j,nxr+1) + dist_yz(k,j,1) )            &
                      * mc_factor * MERGE( 1.0_wp, 0.0_wp,                      &
@@ -1335,5 +1274,5 @@
 !-- Turbulence generation at north and south boundary
     IF ( myidy == id_stg_north  .OR.  myidy == id_stg_south )  THEN
-
+   
        DO  i = nxlg, nxrg
           DO  k = nzb, nzt + 1
@@ -1351,12 +1290,12 @@
              ELSE
                 fv_xz(k,i) = fv_xz(k,i) * EXP( -pi * dt_stg * 0.5_wp / tv(k) ) +     &
-                         fvo_xz(k,i) * SQRT( 1.0_wp - EXP( -pi * dt_stg / tv(k) ) )
+                      fvo_xz(k,i) * SQRT( 1.0_wp - EXP( -pi * dt_stg / tv(k) ) )
              ENDIF
-
+            
              IF ( tw(k) == 0.0_wp )  THEN
                 fw_xz(k,i) = fwo_xz(k,i)
              ELSE
                 fw_xz(k,i) = fw_xz(k,i) * EXP( -pi * dt_stg * 0.5_wp / tw(k) ) +     &
-                         fwo_xz(k,i) * SQRT( 1.0_wp - EXP( -pi * dt_stg / tw(k) ) )
+                      fwo_xz(k,i) * SQRT( 1.0_wp - EXP( -pi * dt_stg / tw(k) ) )
              ENDIF
 !
@@ -1369,19 +1308,20 @@
 
              ELSE
-                dist_xz(k,i,1) = a11(k) * fu_xz(k,i)
+                dist_xz(k,i,1) = MIN( a11(k) * fu_xz(k,i), 3.0_wp )
                 !experimental test of 1.2
-                dist_xz(k,i,2) = ( SQRT( a22(k) / MAXVAL(a22) )                &
-                                         * 1.2_wp )                            &
-                                       * (   a21(k) * fu_xz(k,i)               &
-                                           + a22(k) * fv_xz(k,i) )
-                dist_xz(k,i,3) = ( SQRT(a33(k) / MAXVAL(a33) )                 &
-                                         * 1.3_wp )                            &
-                                       * (   a31(k) * fu_xz(k,i)               &
-                                           + a32(k) * fv_xz(k,i)               &
-                                           + a33(k) * fw_xz(k,i) )
+                dist_xz(k,i,2) = MIN( ( SQRT( a22(k) / MAXVAL(a22) )           &
+                                      * 1.2_wp )                               &
+                                     * (   a21(k) * fu_xz(k,i)                 &
+                                         + a22(k) * fv_xz(k,i) ), 3.0_wp )
+                dist_xz(k,i,3) = MIN( ( SQRT(a33(k) / MAXVAL(a33) )            &
+                                      * 1.3_wp )                               &
+                                    * (   a31(k) * fu_xz(k,i)                  &
+                                        + a32(k) * fv_xz(k,i)                  &
+                                        + a33(k) * fw_xz(k,i) ), 3.0_wp )
              ENDIF
 
           ENDDO
        ENDDO
+
 !
 !--    Mass flux correction following Kim et al. (2013)
@@ -1425,5 +1365,5 @@
 
           DO  i = nxl, nxr
-             DO  k = nzb, nzt
+             DO  k = nzb+1, nzt
                 u(k,-1,i) = ( u(k,-1,i) + dist_xz(k,i,1) )                     &
                       * mc_factor * MERGE( 1.0_wp, 0.0_wp,                     &
@@ -1432,4 +1372,5 @@
                       * mc_factor * MERGE( 1.0_wp, 0.0_wp,                     &
                                            BTEST( wall_flags_0(k,0,i), 2 ) )
+                v(k,-1,i) = v(k,0,i)
                 w(k,-1,i) = ( w(k,-1,i) + dist_xz(k,i,3)  )                    &
                       * mc_factor * MERGE( 1.0_wp, 0.0_wp,                     &
@@ -1441,13 +1382,13 @@
 
           DO  i = nxl, nxr
-             DO  k = nzb, nzt
-                u(k,nyn+1,i) = ( u(k,nyn+1,i) + dist_xz(k,i,1) )                &
-                     * mc_factor * MERGE( 1.0_wp, 0.0_wp,                       &
+             DO  k = nzb+1, nzt
+                u(k,nyn+1,i) = ( u(k,nyn+1,i) + dist_xz(k,i,1) )               &
+                     * mc_factor * MERGE( 1.0_wp, 0.0_wp,                      &
                                           BTEST( wall_flags_0(k,nyn+1,i), 1 ) )
-                v(k,nyn+1,i) = ( v(k,nyn+1,i) + dist_xz(k,i,1) )                &
-                     * mc_factor * MERGE( 1.0_wp, 0.0_wp,                       &
+                v(k,nyn+1,i) = ( v(k,nyn+1,i) + dist_xz(k,i,2) )               &
+                     * mc_factor * MERGE( 1.0_wp, 0.0_wp,                      &
                                           BTEST( wall_flags_0(k,nyn+1,i), 2 ) )
-                w(k,nyn+1,i) = ( w(k,nyn+1,i) + dist_xz(k,i,1) )                &
-                     * mc_factor * MERGE( 1.0_wp, 0.0_wp,                       &
+                w(k,nyn+1,i) = ( w(k,nyn+1,i) + dist_xz(k,i,3) )               &
+                     * mc_factor * MERGE( 1.0_wp, 0.0_wp,                      &
                                           BTEST( wall_flags_0(k,nyn+1,i), 3 ) )
              ENDDO
@@ -1455,4 +1396,7 @@
        ENDIF
     ENDIF
+!
+!-- Finally, set time counter for calling STG to zero
+    time_stg_call = 0.0_wp
 
     CALL  cpu_log( log_point(57), 'synthetic_turbulence_gen', 'stop' )
@@ -1493,6 +1437,6 @@
     REAL(wp) :: rand_sigma_inv  !< inverse of stdev of random number
 
-    REAL(wp), DIMENSION(-merg:merg,nzb:nzt+1)    :: b_y     !< filter func in y-dir
-    REAL(wp), DIMENSION(-merg:merg,nzb:nzt+1)    :: b_z     !< filter func in z-dir
+    REAL(wp), DIMENSION(-merg:merg,nzb:nzt+1)    :: b_y     !< filter function in y-direction
+    REAL(wp), DIMENSION(-merg:merg,nzb:nzt+1)    :: b_z     !< filter function in z-direction
     REAL(wp), DIMENSION(nzb_x_stg:nzt_x_stg+1,nysg:nyng) :: f_n_l   !<  local velocity seed
     REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng)     :: f_n     !<  velocity seed
@@ -1613,5 +1557,5 @@
     INTEGER(iwp), DIMENSION(nzb:nzt+1) :: n_x    !< length scale in x-direction
     INTEGER(iwp), DIMENSION(nzb:nzt+1) :: n_z    !< length scale in z-direction
-    INTEGER(iwp), DIMENSION(nzb:nzt+1) :: n_x2   !< n_y*2
+    INTEGER(iwp), DIMENSION(nzb:nzt+1) :: n_x2   !< n_x*2
     INTEGER(iwp), DIMENSION(nzb:nzt+1) :: n_z2   !< n_z*2
 
@@ -1620,6 +1564,6 @@
     REAL(wp) :: rand_sigma_inv  !< inverse of stdev of random number
 
-    REAL(wp), DIMENSION(-merg:merg,nzb:nzt+1)    :: b_x     !< filter func in y-dir
-    REAL(wp), DIMENSION(-merg:merg,nzb:nzt+1)    :: b_z     !< filter func in z-dir
+    REAL(wp), DIMENSION(-merg:merg,nzb:nzt+1)    :: b_x     !< filter function in x-direction
+    REAL(wp), DIMENSION(-merg:merg,nzb:nzt+1)    :: b_z     !< filter function in z-direction
     REAL(wp), DIMENSION(nzb_y_stg:nzt_y_stg+1,nxlg:nxrg) :: f_n_l   !<  local velocity seed
     REAL(wp), DIMENSION(nzb:nzt+1,nxlg:nxrg)     :: f_n     !<  velocity seed
@@ -1712,3 +1656,453 @@
  END SUBROUTINE stg_generate_seed_xz
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Parametrization of the Reynolds stress tensor, following the parametrization
+!> described in Rotach et al. (1996), which is applied in state-of-the-art
+!> dispserion modelling. Please note, the parametrization does not distinguish
+!> between along-wind and cross-wind turbulence. 
+!------------------------------------------------------------------------------!
+ SUBROUTINE parametrize_reynolds_stress
+
+    USE arrays_3d,                                                             &
+        ONLY:  zu
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) :: k            !< loop index in z-direction
+    
+    REAL(wp)     ::  zzi         !< ratio of z/zi
+    
+!
+!-- 
+    DO  k = nzb+1, nzt+1
+          
+       IF ( zu(k) <= zi_ribulk )  THEN
+!
+!--       Determine normalized height coordinate
+          zzi = zu(k) / zi_ribulk
+!
+!--       u'u' and v'v'. Assume isotropy. Note, add a small negative number
+!--       to the denominator, else the merge-function can crash if scale_l is 
+!--       zero. 
+          r11(k) = scale_us**2 * (                                             &
+                      MERGE( 0.35_wp * (                                       &
+                           - zi_ribulk / ( kappa * scale_l - 10E-4_wp )        &
+                                       )**( 2.0_wp / 3.0_wp ),                 &
+                             0.0_wp,                                           &
+                             scale_l < 0.0_wp )                                &
+                    + 5.0_wp - 4.0_wp * zzi                                    &
+                                 )
+                                 
+          r22(k) = r11(k)
+!
+!--       w'w'
+          r33(k) = scale_wm**2 * (                                             &
+                      1.5_wp * zzi**( 2.0_wp / 3.0_wp ) * EXP( -2.0_wp * zzi ) &
+                    + ( 1.7_wp - zzi ) * ( scale_us / scale_wm )**2            &                     
+                                 )
+!
+!--       u'w' and v'w'. Assume isotropy.
+          r31(k) = - scale_us**2 * (                                           &
+                         1.0_wp - EXP( 3.0_wp * ( zzi - 1.0_wp ) )             &
+                                   )
+                              
+          r32(k) = r31(k)
+!
+!--       For u'v' no parametrization exist so far - ?. For simplicity assume
+!--       a similar profile as for u'w'. 
+          r21(k) = r31(k)
+!
+!--    Above the boundary layer, assmume laminar flow conditions.
+       ELSE
+          r11(k) = 10E-8_wp
+          r22(k) = 10E-8_wp
+          r33(k) = 10E-8_wp
+          r21(k) = 10E-8_wp
+          r31(k) = 10E-8_wp
+          r32(k) = 10E-8_wp
+       ENDIF
+!        write(9,*) zu(k), r11(k), r33(k), r31(k), zi_ribulk, scale_us, scale_wm, scale_l
+    ENDDO
+
+!
+!-- Set bottom boundary condition    
+    r11(nzb) = r11(nzb+1)
+    r22(nzb) = r22(nzb+1)
+    r33(nzb) = r33(nzb+1)
+
+    r21(nzb) = r11(nzb+1)
+    r31(nzb) = r31(nzb+1)
+    r32(nzb) = r32(nzb+1)
+    
+
+ END SUBROUTINE parametrize_reynolds_stress 
+ 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Calculate the coefficient matrix from the Lund rotation. 
+!------------------------------------------------------------------------------!
+ SUBROUTINE calc_coeff_matrix
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) :: k   !< loop index in z-direction
+    
+!
+!-- Calculate coefficient matrix. Split loops to allow for loop vectorization.
+    DO  k = nzb+1, nzt+1
+       IF ( r11(k) > 0.0_wp )  THEN
+          a11(k) = SQRT( r11(k) ) 
+          a21(k) = r21(k) / a11(k)
+          a31(k) = r31(k) / a11(k)
+       ELSE
+          a11(k) = 10E-8_wp
+          a21(k) = 10E-8_wp
+          a31(k) = 10E-8_wp
+       ENDIF
+    ENDDO
+    DO  k = nzb+1, nzt+1
+       a22(k) = r22(k) - a21(k)**2 
+       IF ( a22(k) > 0.0_wp )  THEN
+          a22(k) = SQRT( a22(k) )
+          a32(k) = r32(k) - a21(k) * a31(k) / a22(k)
+       ELSE 
+          a22(k) = 10E-8_wp
+          a32(k) = 10E-8_wp
+       ENDIF
+    ENDDO
+    DO  k = nzb+1, nzt+1
+       a33(k) = r33(k) - a31(k)**2 - a32(k)**2
+       IF ( a33(k) > 0.0_wp )  THEN
+          a33(k) =  SQRT( a33(k) )
+       ELSE
+          a33(k) = 10E-8_wp
+       ENDIF
+    ENDDO   
+!
+!-- Set bottom boundary condition
+    a11(nzb) = a11(nzb+1)
+    a22(nzb) = a22(nzb+1)
+    a21(nzb) = a21(nzb+1)
+    a33(nzb) = a33(nzb+1)    
+    a31(nzb) = a31(nzb+1)
+    a32(nzb) = a32(nzb+1)    
+
+ END SUBROUTINE calc_coeff_matrix
+ 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> This routine controls the re-adjustment of the turbulence statistics used
+!> for generating turbulence at the lateral boundaries.  
+!------------------------------------------------------------------------------!
+ SUBROUTINE stg_adjust
+
+    IMPLICIT NONE
+    
+    INTEGER(iwp) ::  k
+
+    CALL  cpu_log( log_point(57), 'synthetic_turbulence_gen', 'start' )
+!
+!-- Compute mean boundary layer height according to Richardson-Bulk
+!-- criterion using the inflow profiles. Further velocity scale as well as
+!-- mean friction velocity are calculated.
+    CALL calc_scaling_variables
+!
+!-- Set length and time scales depending on boundary-layer height
+    CALL calc_length_and_time_scale
+!
+!-- Parametrize Reynolds-stress tensor, diagonal elements as well
+!-- as r21 (v'u'), r31 (w'u'), r32 (w'v'). Parametrization follows
+!-- Rotach et al. (1996) and is based on boundary-layer depth, 
+!-- friction velocity and velocity scale. 
+    CALL parametrize_reynolds_stress
+!
+!-- Calculate coefficient matrix from Reynolds stress tensor  
+!-- (Lund rotation)
+    CALL calc_coeff_matrix
+!
+!-- Determine filter functions on basis of updated length scales
+    CALL stg_filter_func( nux, bux ) !filter ux
+    CALL stg_filter_func( nuy, buy ) !filter uy
+    CALL stg_filter_func( nuz, buz ) !filter uz
+    CALL stg_filter_func( nvx, bvx ) !filter vx
+    CALL stg_filter_func( nvy, bvy ) !filter vy
+    CALL stg_filter_func( nvz, bvz ) !filter vz
+    CALL stg_filter_func( nwx, bwx ) !filter wx
+    CALL stg_filter_func( nwy, bwy ) !filter wy
+    CALL stg_filter_func( nwz, bwz ) !filter wz
+!
+!-- Reset time counter for controlling next adjustment to zero
+    time_stg_adjust = 0.0_wp
+    
+    CALL  cpu_log( log_point(57), 'synthetic_turbulence_gen', 'stop' )
+    
+ END SUBROUTINE stg_adjust 
+ 
+ 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Calculates turbuluent length and time scales if these are not available
+!> from measurements. 
+!------------------------------------------------------------------------------!
+ SUBROUTINE calc_length_and_time_scale
+
+    USE arrays_3d,                                                             &
+        ONLY:  dzw, ddzw, u_init, v_init, zu, zw
+
+    USE grid_variables,                                                        &
+        ONLY:  ddx, ddy, dx, dy
+        
+    USE statistics,                                                            &
+        ONLY:  hom
+
+    IMPLICIT NONE
+
+
+    INTEGER(iwp) :: k            !< loop index in z-direction
+
+    REAL(wp) ::  length_scale    !< typical length scale
+    
+!
+!-- In initial call the boundary-layer depth can be zero. This case, set 
+!-- minimum value for boundary-layer depth, to setup length scales correctly.
+    zi_ribulk = MAX( zi_ribulk, zw(nzb+2) )
+!
+!-- Set-up default turbulent length scales. From the numerical point of
+!-- view the imposed perturbations should not be immediately dissipated
+!-- by the numerics. The numerical dissipation, however, acts on scales
+!-- up to 8 x the grid spacing. For this reason, set the turbulence 
+!-- length scale to 8 time the grid spacing. Further, above the boundary
+!-- layer height, set turbulence lenght scales to zero (equivalent to not
+!-- imposing any perturbations) in order to save computational costs. 
+!-- Typical time scales are derived by assuming Taylors's hypothesis, 
+!-- using the length scales and the mean profiles of u- and v-component.
+    DO  k = nzb+1, nzt+1
+    
+       length_scale = 8.0_wp * MIN( dx, dy, dzw(k) )
+          
+       IF ( zu(k) <= zi_ribulk )  THEN  
+!
+!--       Assume isotropic turbulence length scales
+          nux(k) = MAX( INT( length_scale * ddx     ), 1 )
+          nuy(k) = MAX( INT( length_scale * ddy     ), 1 )
+          nuz(k) = MAX( INT( length_scale * ddzw(k) ), 1 )
+          nvx(k) = MAX( INT( length_scale * ddx     ), 1 )
+          nvy(k) = MAX( INT( length_scale * ddy     ), 1 )
+          nvz(k) = MAX( INT( length_scale * ddzw(k) ), 1 )
+          nwx(k) = MAX( INT( length_scale * ddx     ), 1 )
+          nwy(k) = MAX( INT( length_scale * ddy     ), 1 )
+          nwz(k) = MAX( INT( length_scale * ddzw(k) ), 1 )
+!
+!--       Limit time scales, else they become very larger for low wind speed, 
+!--       imposing long-living inflow perturbations which in turn propagate
+!--       further into the model domain. Use u_init and v_init to calculate
+!--       the time scales, which will be equal to the inflow profiles, both, 
+!--       in offline nesting mode or in dirichlet/radiation mode. 
+          tu(k)  = MIN( dt_stg_adjust, length_scale /                          &
+                                  ( ABS( u_init(k) ) + 0.1_wp ) )
+          tv(k)  = MIN( dt_stg_adjust, length_scale /                          &
+                                  ( ABS( v_init(k) ) + 0.1_wp ) )
+!
+!--       Time scale of w-component is a mixture from u- and v-component. 
+          tw(k)  = SQRT( tu(k)**2 + tv(k)**2 )
+!
+!--    Above the boundary layer length scales are zero, i.e. imposed turbulence
+!--    is not correlated in space and time, just white noise. This saves
+!--    computations power. 
+       ELSE
+          nux(k) = 0.0_wp
+          nuy(k) = 0.0_wp
+          nuz(k) = 0.0_wp
+          nvx(k) = 0.0_wp
+          nvy(k) = 0.0_wp
+          nvz(k) = 0.0_wp
+          nwx(k) = 0.0_wp
+          nwy(k) = 0.0_wp
+          nwz(k) = 0.0_wp
+          
+          tu(k)  = 0.0_wp
+          tv(k)  = 0.0_wp
+          tw(k)  = 0.0_wp
+       ENDIF
+    ENDDO
+!
+!-- Set bottom boundary condition for the length and time scales 
+    nux(nzb) = nux(nzb+1)
+    nuy(nzb) = nuy(nzb+1)
+    nuz(nzb) = nuz(nzb+1)
+    nvx(nzb) = nvx(nzb+1)
+    nvy(nzb) = nvy(nzb+1)
+    nvz(nzb) = nvz(nzb+1)
+    nwx(nzb) = nwx(nzb+1)
+    nwy(nzb) = nwy(nzb+1)
+    nwz(nzb) = nwz(nzb+1)
+
+    tu(nzb)  = tu(nzb+1)
+    tv(nzb)  = tv(nzb+1)
+    tw(nzb)  = tw(nzb+1)
+
+
+ END SUBROUTINE calc_length_and_time_scale 
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Calculate scaling variables which are used for turbulence parametrization
+!> according to Rotach et al. (1996). Scaling variables are: friction velocity,
+!> boundary-layer depth, momentum velocity scale, and Obukhov length. 
+!------------------------------------------------------------------------------!
+ SUBROUTINE calc_scaling_variables
+
+
+    USE control_parameters,                                                    &
+        ONLY:  bc_dirichlet_l, bc_dirichlet_n, bc_dirichlet_r, bc_dirichlet_s, &
+               humidity, pt_surface
+             
+    USE indices,                                                               &
+        ONLY:  nx, ny  
+        
+    USE surface_mod,                                                           &
+        ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) :: i            !< loop index in x-direction
+    INTEGER(iwp) :: j            !< loop index in y-direction
+    INTEGER(iwp) :: k            !< loop index in z-direction
+    INTEGER(iwp) :: k_ref        !< index in z-direction for reference height 
+    INTEGER(iwp) :: m            !< surface element index
+
+    REAL(wp) ::  friction_vel_l         !< mean friction veloctiy on subdomain
+    REAL(wp) ::  shf_mean               !< mean surface sensible heat flux
+    REAL(wp) ::  shf_mean_l             !< mean surface sensible heat flux on subdomain
+    REAL(wp) ::  u_int                  !< u-component
+    REAL(wp) ::  v_int                  !< v-component
+    REAL(wp) ::  vpt_surface            !< near-surface virtual potential temperature
+    REAL(wp) ::  w_convective           !< convective velocity scale
+    REAL(wp) ::  z0_mean                !< mean roughness length
+    REAL(wp) ::  z0_mean_l              !< mean roughness length on subdomain
+   
+!
+!-- Mean friction velocity and velocity scale. Therefore, 
+!-- pre-calculate mean roughness length and surface sensible heat flux
+!-- in the model domain, which are further used to estimate friction 
+!-- velocity and velocity scale. Note, for z0 linear averaging is applied,
+!-- even though this is known to unestimate the effective roughness.
+!-- This need to be revised later.
+    z0_mean_l  = 0.0_wp
+    shf_mean_l = 0.0_wp
+    DO  m = 1, surf_def_h(0)%ns
+       z0_mean_l  = z0_mean_l  + surf_def_h(0)%z0(m)
+       shf_mean_l = shf_mean_l + surf_def_h(0)%shf(m)
+    ENDDO    
+    DO  m = 1, surf_lsm_h%ns
+       z0_mean_l  = z0_mean_l  + surf_lsm_h%z0(m)
+       shf_mean_l = shf_mean_l + surf_lsm_h%shf(m)
+    ENDDO
+    DO  m = 1, surf_usm_h%ns
+       z0_mean_l  = z0_mean_l  + surf_usm_h%z0(m)
+       shf_mean_l = shf_mean_l + surf_usm_h%shf(m)
+    ENDDO
+    
+#if defined( __parallel )
+    CALL MPI_ALLREDUCE( z0_mean_l, z0_mean, 1, MPI_REAL, MPI_SUM,              &
+                        comm2d, ierr )
+    CALL MPI_ALLREDUCE( shf_mean_l, shf_mean, 1, MPI_REAL, MPI_SUM,            &
+                        comm2d, ierr )
+#else
+    z0_mean  = z0_mean_l
+    shf_mean = shf_mean_l
+#endif
+    z0_mean  = z0_mean  / REAL( ( nx + 1 ) * ( ny + 1 ), KIND = wp )
+    shf_mean = shf_mean / REAL( ( nx + 1 ) * ( ny + 1 ), KIND = wp )
+        
+!
+!-- Note, Inifor does not use logarithmic interpolation of the 
+!-- velocity components near the ground, so that near-surface
+!-- wind speed and thus the friction velocity is overestimated. 
+!-- However, friction velocity is used for turbulence 
+!-- parametrization, so that more physically meaningful values are important.
+!-- Hence, derive friction velocity from wind speed at a reference height.
+!-- For a first guess use 20 m, which is in the range of the first 
+!-- COSMO vertical level. 
+    k_ref = MINLOC( ABS( zu - cosmo_ref ), DIM = 1 ) - 1
+    
+    friction_vel_l = 0.0_wp
+    IF ( bc_dirichlet_l  .OR.  bc_dirichlet_r )  THEN
+       
+       i = MERGE( -1, nxr + 1, bc_dirichlet_l )
+
+       DO  j = nys, nyn
+!
+!--       Note, in u- and v- component the imposed perturbations 
+!--       from the STG are already included. Check whether this 
+!--       makes any difference compared to using the pure-mean 
+!--       inflow profiles. 
+          u_int = MERGE( u(k_ref,j,i+1), u(k_ref,j,i), bc_dirichlet_l )
+          v_int = v(k_ref,j,i)
+!
+!--       Calculate friction velocity and sum-up. Therefore, assume 
+!--       neutral condtions.
+          friction_vel_l = friction_vel_l + kappa *                            &
+                            SQRT( u_int * u_int + v_int * v_int )  /           &
+                            LOG( zu(k_ref) / z0_mean )
+          
+       ENDDO
+       
+    ENDIF
+    
+    IF ( bc_dirichlet_s  .OR.  bc_dirichlet_n )  THEN
+       
+       j = MERGE( -1, nyn + 1, bc_dirichlet_s )
+    
+       DO  i = nxl, nxr
+          
+          u_int = u(k_ref,j,i)
+          v_int = MERGE( v(k_ref,j+1,i), v(k_ref,j,i), bc_dirichlet_s )
+ 
+          friction_vel_l = friction_vel_l + kappa *                            &
+                            SQRT( u_int * u_int + v_int * v_int )  /           &
+                            LOG( zu(k_ref) / z0_mean )                       
+          
+       ENDDO
+       
+    ENDIF
+    
+#if defined( __parallel )
+    CALL MPI_ALLREDUCE( friction_vel_l, scale_us, 1, MPI_REAL, MPI_SUM,        &
+                        comm2d, ierr )
+#else
+    scale_us = friction_vel_l
+#endif
+    scale_us = scale_us / REAL( 2 * nx + 2 * ny, KIND = wp )
+    
+!
+!-- Compute mean Obukhov length
+    IF ( shf_mean > 0.0_wp )  THEN
+       scale_l = - pt_surface / ( kappa * g ) * scale_us**3 / shf_mean
+    ELSE
+       scale_l = 0.0_wp
+    ENDIF
+    
+!
+!-- Compute mean convective velocity scale. Note, in case the mean heat flux 
+!-- is negative, set convective velocity scale to zero.
+    IF ( shf_mean > 0.0_wp )  THEN
+       w_convective = ( g * shf_mean * zi_ribulk / pt_surface )**( 1.0_wp / 3.0_wp )
+    ELSE
+       w_convective = 0.0_wp
+    ENDIF
+!
+!-- Finally, in order to consider also neutral or stable stratification, 
+!-- compute momentum velocity scale from u* and convective velocity scale, 
+!-- according to Rotach et al. (1996). 
+    scale_wm = ( scale_us**3 + 0.6_wp * w_convective**3 )**( 1.0_wp / 3.0_wp )
+   
+ END SUBROUTINE calc_scaling_variables
+
  END MODULE synthetic_turbulence_generator_mod
